﻿var jsonPath;

function importJSON(doc){

  var projJSON = loadJSONFileDialog();
  
  tf = titlePage.textFrames.add({
    geometricBounds: [27.992, 38.3, 112.658, 96.7],
    contents: projJSON.response.timeframe.info + '\n' + projJSON.response.category.info + '\r\r'+ projJSON.response.title
  });

  tf.paragraphs.everyItem().appliedParagraphStyle = doc.paragraphStyles.itemByName('h1');
  tf.paragraphs.firstItem().appliedParagraphStyle = doc.paragraphStyles.itemByName('h3');

  descriptTF = titlePage.textFrames.add({
    geometricBounds: [86.2, 22.7, 123.242, 112.3],
    contents: projJSON.response.description
  });

  descriptTF.paragraphs.everyItem().appliedParagraphStyle = doc.paragraphStyles.itemByName('quote');

  var titleImagePage = doc.pages.add();
  app.activeWindow.activePage = titleImagePage; 

  var rect1 = titleImagePage.rectangles.add({geometricBounds:[0,0,myDocPref.ph,myDocPref.pw]});
  var imagePath = jsonPath + "/"+ projJSON.response.image.path;
  if(File(imagePath).exists){

    rect1.place(File(imagePath));
    rect1.fit(FitOptions.FILL_PROPORTIONALLY);
    rect1.fit(FitOptions.CENTER_CONTENT);
    rect1.strokeWeight = 0;
  }
  else{
    alert('image file not found');
  }
  
  workspaceTF = titleImagePage.textFrames.add({
    geometricBounds: [22.7, 22.7, 91.492, 112.3]
  });

  if(projJSON.response.workspace){
    workspaceTF.contents = projJSON.response.workspace.text;
  }
  else{
    workspaceTF.contents = 'Insert any Text';
  }
  workspaceTF.paragraphs.everyItem().appliedParagraphStyle = doc.paragraphStyles.itemByName('quote');

  authorsTF = titleImagePage.textFrames.add({
    geometricBounds: [107.365, 22.7, 176.16 , 65.5],
    contents: 'erstellt von \r'
  });

  for( var i = 0; i < projJSON.response.authors.length; i++){
    authorsTF.contents += projJSON.response.authors[i].name +'\r';
  }
  authorsTF.paragraphs.everyItem().appliedParagraphStyle = doc.paragraphStyles.itemByName('AutorenBetreuer');
  authorsTF.paragraphs.firstItem().appliedParagraphStyle = doc.paragraphStyles.itemByName('text');

  supervisorsTF = titleImagePage.textFrames.add({
    geometricBounds: [144.408 , 22.7, 176.16, 65.5],
    contents: 'betreut durch \r'
  });

  for( var i = 0; i < projJSON.response.supervisors.length; i++){
    supervisorsTF.contents += projJSON.response.supervisors[i].name +'\r';
  }
  supervisorsTF.paragraphs.everyItem().appliedParagraphStyle = doc.paragraphStyles.itemByName('AutorenBetreuer');
  supervisorsTF.paragraphs.firstItem().appliedParagraphStyle = doc.paragraphStyles.itemByName('text');


  var infoPage = doc.pages.add();
  app.activeWindow.activePage = infoPage; 
  
  tf02 = infoPage.textFrames.add({
    geometricBounds: [myDocPref.top, myDocPref.right, myDocPref.ph - myDocPref.bottom, myDocPref.pw - myDocPref.left]
  });
  var projectText = '';
  for( var i = 0; i < projJSON.response.posts.length; i++){
    
    
    if (projJSON.response.posts[i].title && projJSON.response.posts[i].text){
      projectText = projectText + '\r'  + '##' + projJSON.response.posts[i].title + '\r';
    }
    if (projJSON.response.posts[i].text){
      projectText = projectText + '\r'  + projJSON.response.posts[i].text + '\r';
    }
  }

  // included incom2indesign.jsx from markdown2ID.jsx
  getMarkdown(tf02, projectText);
  
  while (tf02.parentStory.textContainers[tf02.parentStory.textContainers.length-1].overflows) { 
        
    var anotherPage = doc.pages.add();
    app.activeWindow.activePage = anotherPage;       
    var myNewTF = anotherPage.textFrames.add({
      geometricBounds: [myDocPref.top, myDocPref.right, myDocPref.ph - myDocPref.bottom, myDocPref.pw - myDocPref.left]
  });
    myNewTF.itemLayer = tf02.parentStory.textContainers[tf02.parentStory.textContainers.length-1].itemLayer;   
    myNewTF.previousTextFrame = tf02.parentStory
    .textContainers[tf02.parentStory.textContainers.length-1];
  } 

}

function loadJSONFileDialog(){
  var myJSONfile = File.openDialog("Choose your JSON file","*.json",false);
  if(myJSONfile != false){
    myJSONfile.open('r');
    myJSONObject = eval("(" + myJSONfile.read() + ")");
    jsonPath = myJSONfile.path;
    //alert(jsonPath);
    myJSONfile.close(); // always close files after reading
    
    return myJSONObject;
    
  }
  else{
    alert("You did not choose any JSON file!");
    return;
  }
}