#Incom 2 Indesign

This example is about getting your incom project into Adobe InDesign.

##getIncomProject.py

**For running this script you'll need to install [Requests: HTTP for Humans](http://docs.python-requests.org/en/latest/)**
First of all we are going to download the json file of a specified project with all the connected material on our system. To do this we need to run this script from our console. So open up a terminal navigate to the folder where the script is located and type:

    $ python getIncomProject.py

There will be a prompt demanding a valid project number like this:

    Please enter project number: 

When you have entered a valid number an the project is visible for anybody you should see a new folder named "Project[projectnumber]". Inside the folder you'll find two json files one named [projectnumber].json which is the original json file provided by incom and another named [projectnumber]InDesign.json which has changed URLS fr the later use in Indesign. The third object you'll see is another folder called files which contains all downloadable files connected with this project.

##InDesignScripts

This folder contains what it says: script for Adobe Indesign. This is why you need to move this folder to: '~/Library/Preferences/Adobe InDesign/Version 7.5/en_GB/Scripts/Scripts Panel/' and maybe rename it to 'Incom2InDesign' but it's up to you.

Let's take a closer look to the scripts:

###incom2indesign.jsx
This is the main script which you need to click from within Indesign to get this whole engine started. All other script are included in this script.

###buildDocument.jsx
This script keeps the preferences of your document. By default the layout is for A5. If you want another document size or more columns or a wider gutter, you can change this here. Please, feel free to do so!

###getStyles.jsx
This is a function called from witin buildDocument.jsx. When the engine is running you will be asked to choose an InDesign document to load the styles (paragraph styles, character styles, object styles, etc.) from. This file need to provide the following styles:

**Character Styles**

+    strong
+    em
+    strongem
+    code
+    hyperlink

**Paragraph Styles**

+    text
+    quote
+    pre
+    h1
+    h2
+    h3
+    h4
+    h5
+    h6
+    bullet
+    numbered
+    indent
+    hrule
+    th
+    td
  
**Table Style**

+    table

**Cell Styles**

+    header
+    body

If you are a little bit familiar with web design you know what these styles are good for. If you don't have any clue, you can read about the text formatting elements of HTML on [SitePoint.](http://reference.sitepoint.com/html/elements-text-formatting)

###importJSON.jsx

When called this script ask you which json file you want to import. **Please use one with the InDesign extension, like 1234InDesign.json!** On the first three pages it will place text based information like the title of the project, the authors and supervisors and teh title image then it will place the whole project text into connected textframes over several pages until there is no overset text anymore.
This script contains layout descisions! Please, feel free to change them!

###markdown2ID.jsx
This script runs more or less in the background, is called from within importJSON.jsx and converts the project text from markdown to InDesign styles.

That's it folks! Have fun with this script suit and maybe it helps you to make your print documentation for your colloquii!
